Uploaded image for project: 'Puppet'
  1. Puppet
  2. PUP-5548

Debian provider fails on Debian 8 systems without systemd present

    XMLWordPrintable

    Details

    • Type: Bug
    • Status: Closed
    • Priority: Normal
    • Resolution: Fixed
    • Affects Version/s: PUP 4.3.0
    • Fix Version/s: PUP 4.3.2
    • Component/s: None
    • Labels:
      None
    • Environment:

      Debian 8 / Ubuntu 15.04 where systemd has been removed or is otherwise not present.

    • Template:
    • Story Points:
      1
    • Sprint:
      Client 2015-12-16, Client 2015-12-30
    • Release Notes:
      Bug Fix
    • Release Notes Summary:
      Hide
      This change fixes an issue in the Debian service provider in Debian 8 and Ubuntu 15.04 where we erroneously expected `systemctl` to be functional, when it is possible to purge systemd from the system and use sysvinit. Instead of using `systemctl` to determine system status on these platforms, we now use the `service` command, which is an abstraction around each of the available init systems in the Debian family of platforms.
      Show
      This change fixes an issue in the Debian service provider in Debian 8 and Ubuntu 15.04 where we erroneously expected `systemctl` to be functional, when it is possible to purge systemd from the system and use sysvinit. Instead of using `systemctl` to determine system status on these platforms, we now use the `service` command, which is an abstraction around each of the available init systems in the Debian family of platforms.

      Description

      https://github.com/puppetlabs/puppet/commit/75160b78dc4a9189949da50a6b76e42172a45770#commitcomment-14619787 added a bit of logic in the Debian provider for Debian 8 / Ubuntu 15.04 and newer systems to use systemctl to properly determine service status. However, it's possible to remove systemd from a Debian 8 system all together and run entirely with sysvinit. In such a case, the provider will fail as systemctl doesn't exist.

      The provider should check that systemctl exists before attempting to use it in Debian 8 / Ubuntu 15.04.

        Attachments

          Issue Links

            Activity

              People

              Assignee:
              john.duarte John Duarte
              Reporter:
              whopper William Hopper
              Votes:
              0 Vote for this issue
              Watchers:
              3 Start watching this issue

                Dates

                Created:
                Updated:
                Resolved:

                  Zendesk Support